/* 
    Copyright (C) 2004  Mika Raento - Renaud Petit

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    email: mraento@cs.helsinki.fi - petit@cs.helsinki.fi 
*/


#if !defined(DISCOVER_H_INCLUDED)

#define DISCOVER_H_INCLUDED

#include <e32base.h>
#include <f32file.h>
#include <e32std.h>

#include "log_base_impl.h"

#include <es_sock.h>
#include <bt_sock.h>

class Cdiscover: public CCheckedActive, public Mlog_base_impl
{
public:
	~Cdiscover();
	
	const TDesC& get_value();
	
	static Cdiscover* NewL(MApp_context& Context);
private:
	void ConstructL();
	Cdiscover(MApp_context& Context);
	virtual void DoCancel();
	virtual void CheckedRunL();
private:
	enum comm_state { IDLE, FIRST_SEARCH, NEXT_SEARCH };
	comm_state current_state;
	TBuf<1024> names;
	TBuf<1024> prev_env;

	RHostResolver hr; bool hr_is_open;
	RSocket socket; bool socket_is_open;
	RSocketServ socket_server; bool socket_server_is_open;
	TInquirySockAddr addr;
	TNameEntry name;
	TProtocolDesc pInfo;

	RTimer timer; bool timer_is_open;

	void release();
	void finished();
	void Restart();
	
public:

};

#endif